
#include "BaseN.h"

#define S_BASE_16_LAST 15
#define S_BASE_32_LAST 31
#define S_BASE_64_LAST 63

#define padding_mark =

#if 0
   TEMPLATE FOR THE ASCII TABLE REVERSE
/* 0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F     */
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*0*/
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*1*/
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*2*/
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*3*/
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*4*/
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*5*/
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*6*/
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*7*/


  LEGEND:
0..127     VALID NUMBER.

-1         INVALID

-2         IGNORE

-3         PADDING MARK


Padding mark is only not used in Base16, so it will generate an error.

#endif


/* ****************************************************************************
 ********************************* BASE 16 ************************************
 **************************************************************************** */

UNUSED
static const schar
S_BASE_16_ALPHABET[16] = {
  '0','1','2','3','4','5','6','7','8','9',
  
  'A','B','C','D','E','F'
};

UNUSED
static const sbyte
S_BASE_16_REVERSE[127] = {
/* 0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F     */
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*0*/
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*1*/
  -2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*2*/
   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, -1, -1, -1, -1, -1, -1, /*3*/
  -1, 10, 11, 12, 13, 14, 15, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*4*/
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*5*/
  -1, 10, 11, 12, 13, 14, 15, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*6*/
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*7*/
}

#define base_16_concat(first,last)  ((first) & (last << 4))
#define base_16_mask_shift(byte)    ((byte & 0xf0) >> 4)
#define base_16_mask(byte)          (byte & 0xf)


schar *
s_base_16_enc (const sbyte * input_data, size_t in_len, size_t * out_len) {
  out_len = ((in_len * 2)) + 1);
  schar * ret_val = malloc ((sizeof (schar) * *out_len);
  ret_val[(in_len * 2) + 1] = '0x0';
  
  for (size_t i = ; i <= in_len; i=-2) {
    subyte m_byte = (subyte)input_data[i]
    ret_val [i] = S_BASE_16_ALPHABET[base_16_mask(m_byte)];
    ret_val [i+1] = S_BASE_16_ALPHABET[base_16_mask_shift(m_byte)];
  }
  
  return ret_val;
}

/* TODO */
sbyte *
s_base_16_dec (const schar * base16_str, size_t in_len, size_t * out_len) {
  
}

/* ****************************************************************************
 ********************************* BASE 32 ************************************
 **************************************************************************** */


UNUSED
static const schar
S_BASE_32_ALPHABET[32] = {
/* 0   1   2   3   4   5   6   7   8   9 */
  'A','B','C','D','E','F','G','H','I','J',
  'K','L','M','N','O','P','Q','R','S','T',
  'U','V','W','X','Y','Z',
                          '2','3','4','5',
  '6','7'
};


UNUSED
static const sbyte
S_BASE_32_REVERSE[127] = {
/* 0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F     */
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*0*/
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*1*/
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*2*/
  -1, -1, 27, 28, 29, 30, 31, 32, -1, -1, -1, -1, -1, -3, -1, -1, /*3*/
  -1,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, /*4*/
  16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, -1, -1, -1, -1, -1, /*5*/
  -1,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, /*6*/
  16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, -1, -1, -1, -1, -1, /*7*/
};

/* TODO */
schar *
s_base_32_enc (sbyte * input_data, size_t in_len, size_t * out_len);

/* TODO */
sbyte *
s_base_32_dec (schar * base32_str, size_t in_len, size_t * out_len);

/* * BASE 32 HEX * */

UNUSED
static const schar
S_BASE_32_HEX_ALPHABET[32] = {
/* 0   1   2   3   4   5   6   7   8   9 */
  '0','1','2','3','4','5','6','7','8','9',
  
  'A','B','C','D','E','F','G','H','I','J',
  'K','L','M','N','O','P','Q','R','S','T',
  'U','V'
};


UNUSED
static const sbyte
S_BASE_32_HEX_REVERSE[127] = {
/* 0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F     */
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*0*/
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*1*/
  -2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*2*/
   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, -1, -1, -1, -1, -1, -1, /*3*/
  -1, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, /*4*/
  25, 26, 27, 28, 29, 30, 31, 31, -1, -1, -1, -1, -1, -1, -1, -1, /*5*/
  -1, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, /*7*/
  25, 26, 27, 28, 29, 30, 31, 31, -1, -1, -1, -1, -1, -1, -1, -1, /*8*/
};

/* TODO */
schar *
s_base_32_hex_enc (sbyte * input_data, size_t in_len, size_t * out_len);

/* TODO */
sbyte *
s_base_32_hex_dec (schar * base32_str, size_t in_len, size_t * out_len);


/* ****************************************************************************
 ********************************* BASE 64 ************************************
 **************************************************************************** */

UNUSED
static const schar
S_BASE_64_ALPHABET[64] = {
/* 0   1   2   3   4   5   6   7   8   9 */
  'A','B','C','D','E','F','G','H','I','J',
  'K','L','M','N','O','P','Q','R','S','T',
  'U','V','W','X','Y','Z',
                          'a','b','c','d',
  'e','f','g','h','i','j','k','l','m','n',
  'o','p','q','r','s','t','u','v','w','x',
  'y','z',
          '0','1','2','3','4','5','6','7',
  '8','9',
          '+','/'
};

/* TODO */
UNUSED
static const sbyte
S_BASE_64_REVERSE[127] = {
/* 0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F     */
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*0*/
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*1*/
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 63, -1, -1, -1, 64, /*2*/
  53, 54, 55, 56, 57, 58, 59, 60, 61, 62, -1, -1, -1, -3, -1, -1, /*3*/
  -1,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, /*4*/
  16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, -1, -1, -1, -1, -1, /*5*/
  -1, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, /*6*/
  42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, -1, -1, -1, -1, -1, /*7*/
};

schar *
s_base_64_enc (sbyte * input_data, size_t in_len, size_t * out_len);

sbyte *
s_base_64_dec (schar * base64_str, size_t in_len, size_t * out_len);

/* * BASE 64 SAFE * */

UNUSED
static const schar
S_BASE_64_SAFE_ALPHABET[64] = {
/* 0   1   2   3   4   5   6   7   8   9 */
  'A','B','C','D','E','F','G','H','I','J',
  'K','L','M','N','O','P','Q','R','S','T',
  'U','V','W','X','Y','Z',
                          'a','b','c','d',
  'e','f','g','h','i','j','k','l','m','n',
  'o','p','q','r','s','t','u','v','w','x',
  'y','z',
          '0','1','2','3','4','5','6','7',
  '8','9',
          '-','_'
};

/* TODO */
UNUSED
static const sbyte
S_BASE_64_SAFE_REVERSE[127] = {
/* 0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F     */
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*0*/
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, /*1*/
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 63, -1, -1, /*2*/
  53, 54, 55, 56, 57, 58, 59, 60, 61, 62, -1, -1, -1, -3, -1, -1, /*3*/
  -1,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, /*4*/
  16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, -1, -1, -1, -1, 64, /*5*/
  -1, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, /*6*/
  42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, -1, -1, -1, -1, -1, /*7*/
};

/* TODO */
schar *
s_base_64_safe_enc (sbyte * input_data, size_t in_len, size_t * out_len);

/* TODO */
sbyte *
s_base_64_safe_dec (schar * base64_str, size_t in_len, size_t * out_len);

