/*
Copyright (c) 2013-2014 Gustav Hartvigsson

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

/**
 * @file
 * @mainpage SSTS -- The (Super) Simple Type System
 * @author Gustav Hartvigsson
 * @version 0.0.1-bzr (dev)
 * 
 * @section About
 * The (Super) Simple Type System is -- yet -- only an experiment. The base
 * for (almost) all objects in the system are derived from @ref SObject .
 * 
 * 
 * 
 */



/** @file */

#ifndef __H_SIMPLE_TYPE_SYSTEM__
#define __H_SIMPLE_TYPE_SYSTEM__

#include "config.h"

#include "baseobject.h"
#include "Box.h"
#include "Callback.h"
#include "defs.h"
#include "DynamicArray.h"
#include "Error.h"
#include "Func.h"
#include "hash.h"
#include "Interface.h"
#include "MainLoop.h"
#include "Map.h"
#include "Matrix.h"
#include "utils.h"


BEGIN_DECLS

/**
 * Returns a string representing the current version.
 */
char *
s_get_version_string ();

/**
 * Returns the Major version as on int.
 */
int
s_get_version_major ();

/**
 * Returns the Minor version as on int.
 */
int
s_get_version_minor ();

/**
 * Returns the Patch version as on int.
 */
int
s_get_version_patch ();


END_DECLS

#endif
